----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:41:05 04/09/2009 
-- Design Name: 
-- Module Name:    kcbaud - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity kcbaud is
    Port ( SYSCLK : in  STD_LOGIC;
           BAUDx16 : out  STD_LOGIC);
end kcbaud;

architecture Behavioral of kcbaud is

signal baud_count: integer range 0 to 127 :=0;


begin

  -- Set baud rate to 38400 for the UART communications -cm
  -- Requires en_16_x_baud to be 614400Hz which is a single cycle pulse every 81 cycles at 50MHz 
  --
  -- NOTE : If the highest value for baud_count exceeds 127 you will need to adjust 
  --        the range of integers in the signal declaration for baud_count.
  --

  baud_timer: process(SYSCLK)
  begin
    if SYSCLK'event and SYSCLK='1' then
      if baud_count=80 then
           baud_count <= 0;
         BAUDx16 <= '1';
       else
           baud_count <= baud_count + 1;
         BAUDx16 <= '0';
      end if;
    end if;
  end process baud_timer;

end Behavioral;

